//
//  GMlib -- Graphics & Media Lab Common Source Library
//
//  $Id: gmlfreecamera.h,v 1.1 2004/02/12 13:29:00 leo Exp $
//
//  Copyright (C) 2004, Moscow State University Graphics & Media Lab
//  gmlsupport@graphics.cs.msu.su
//  
//  This file is part of GMlib software.
//  For conditions of distribution and use, see the accompanying README file.

/** @file gmlgenericcamera.h
 *  @brief A class for generic 3d virtual camera
 * 
 */

#ifndef _GMLFREECAMERA_H_
#define _GMLFREECAMERA_H_

#include "gmlgenericcamera.h"

namespace gml
{
  /** @addtogroup Utils3D
   * @{
   */

  /// Class representing any 3d virtual camera (view and projection matrices)
  class FreeCamera: public GenericCamera
  {
    public:

      FreeCamera()
        {  } 
     
      FreeCamera(const Matrix4x4d& view_transform,
                 const Matrix4x4d& proj_transform)
        {
        SetViewTransform(view_transform);
        SetProjectionTransform(proj_transform);
        }

      virtual GenericCamera* Clone() const
       {
       return new FreeCamera(*this);
       }


     void SetViewTransform(const Matrix4x4d& view_transform)
      {
        GenericCamera::SetViewTransform(view_transform);
      }

      void SetProjectionTransform(const Matrix4x4d& proj_transform)
      {
        GenericCamera::SetProjectionTransform(proj_transform);
      }

  };

  /** @} */
} // namespace gml

#endif
