#ifndef _RECTANGLE_H_
#define _RECTANGLE_H_

// parent include
#include "animobject.h"

namespace cganim
  {
  
  
  /// @brief Represents arbitrary quad given by four 3d points
  /// @attention Points should in general lie on a single plane
  class Rectangle: public AnimObject
    {
    public:

      /// Default constructor
      Rectangle()
        {
        m_corners[0].SetValue(-1, -1, 0);
        m_corners[1].SetValue(1, -1, 0);
        m_corners[2].SetValue(1, 1, 0);
        m_corners[3].SetValue(-1, 1, 0);
        }

      /// Return corner of the rect
      gml::Vector3d GetCorner(int i) const
        {
        return m_corners[i];
        }


      /// Modify corner of the rect
      void SetCorner(int i, const gml::Vector3d& corner)
        {
        m_corners[i] = corner;
        }

    private:

      /// four rectangle corners
      gml::Vector3d m_corners[4];

    };
  }


#endif