#ifndef _SPHERE_H_
#define _SPHERE_H_


// parent include
#include "animobject.h"

// own includes

namespace cganim
  {

  /// Represents a sphere given by its center and radius
  class Sphere: public AnimObject
    {
    public:

      Sphere()
        : m_radius(1), m_pos(0, 0, 0)
        { }

      /// Return sphere radius
      double GetRadius() const
        { return m_radius; }

      /// Modify sphere radius
      void SetRadius(double new_radius)
        { m_radius = new_radius; }

      /// Return sphere center
      gml::Vector3d GetCenter() const
        { return m_pos; }

      /// Modify sphere center
      void SetCenter(const gml::Vector3d& new_center)
        { m_pos = new_center; }

    private:
      /// Sphere radius
      double m_radius;
      /// Sphere center position
      gml::Vector3d m_pos;

    };

  }



#endif