// animdata_load_sample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

// include GML lib required include
#include "../csl/base/gmlcommon.h"

// include animdata headers
#include "../animdata/include/animdata.h"
#include "../animdata/include/exception.h"
#include "../animdata/include/sphere.h"
#include "../animdata/include/rectangle.h"

using namespace gml;
using namespace cganim;

int _tmain(int argc, _TCHAR* argv[])
{  	


  AnimationData* anim_data = new AnimationData;
  
  
  
  try
    {
    anim_data->Load("..\\demos\\simple.cganim");
    }
  catch(IOException& ex)
    {
    printf("Loading error: %s", ex.What().c_str());
    return -1;
    }

  for(int i = 0; i < anim_data->GetNObjects(); ++i)
    {
    AnimObject* obj = anim_data->GetAnimObject(i);

    Sphere* sphere = dynamic_cast<Sphere*>(obj);
    if (sphere != NULL)
      {
      printf("Sphere object found\n");
      continue;
      }

    Rectangle* rect = dynamic_cast<Rectangle*>(obj);
    if (rect != NULL)
      {
      printf("Rect object found\n");
      continue;
      };
    }
  delete anim_data;

  getchar();

  
  return 0;
}

